<?php

/*  Copyright (C) 2019       Nicolas ZABOURI     <info@inovea-conseil.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file    bankwire/bankwire.class.php
 * \ingroup bankwire
 * \brief   This file is an example for a CRUD class file (Create/Read/Update/Delete)
 *          Put some comments here
 */
// Put here all includes required by your class file
require_once DOL_DOCUMENT_ROOT . '/core/class/commonobject.class.php';
require_once DOL_DOCUMENT_ROOT . '/user/class/user.class.php';
require_once DOL_DOCUMENT_ROOT . '/product/class/product.class.php';
require_once DOL_DOCUMENT_ROOT . '/fourn/class/fournisseur.product.class.php';
require_once DOL_DOCUMENT_ROOT . '/categories/class/categorie.class.php';

dol_include_once('importupdateproduct/lib/PHPExcel/IOFactory.php');

/**
 * Class Bankwire
 *
 * Put here description of your class
 *
 * @see CommonObject
 */
class Importupdateproduct extends CommonObject
{

	/**
	 * Constructor
	 *
	 * @param DoliDb $db Database handler
	 */
	public function __construct(DoliDB $db)
	{
		$this->db = $db;
	}

	public function sheettest($file)
	{
		global $user, $conf, $langs;
		if (file_exists($file)) {
			// Chargement du fichier Excel
			$objPHPExcel = PHPExcel_IOFactory::load($file);

			/**
			 * récupération de la première feuille du fichier Excel
			 * @var PHPExcel_Worksheet $sheet
			 */
			$sheet = $objPHPExcel->getSheet(0);

			$error = 0;
			echo '<table class="tagtable liste"><tr>
			<th>' . $langs->trans("Line") . '</th>
			<th>' . $langs->trans("Ref") . '</th>
			<th>' . $langs->trans("Label") . '</th>
			<th>' . $langs->trans("Description") . '</th>
			<th>' . $langs->trans("SellingPrices") . '</th>
			<th>' . $langs->trans("VAT") . '</th>
			<th>' . $langs->trans("EAN13") . '</th>
			<th>' . $langs->trans("ProductAccountancySellCode") . '</th>
			<th>' . $langs->trans("ProductAccountancyBuyCode") . '</th>
			<th>' . $langs->trans("ProductAccountancySellIntraCode") . '</th>
			<th>' . $langs->trans("Warehouse") . '</th>
			<th>' . $langs->trans("Ecotax") . '</th>
			<th>' . $langs->trans("Sorecop") . '</th>
			<th>' . $langs->trans("Mark") . '</th>
			<th>' . $langs->trans("Range") . '</th>
			<th>' . $langs->trans("Category") . '</th>
			<th>' . $langs->trans("OnSell") . '</th>
			<th>' . $langs->trans("OnBuy") . '</th>
			<th>' . $langs->trans("Supplier") . '</th>
			<th>' . $langs->trans("SupplierPrice") . '</th>
			<th>' . $langs->trans("SupplierVat") . '</th>
			<th>' . $langs->trans("SupplierQty") . '</th>
			</tr>';

			// On boucle sur les lignes
			$i = 0;
			$j = 1;
			foreach ($sheet->getRowIterator() as $valline => $row) {
				if ($i == 0) {
					$i = 1;
					continue;
				}

				$ref = $sheet->getCell("A" . $valline)->getFormattedValue();
				$label = $sheet->getCell("B" . $valline)->getFormattedValue();
				$desc = $sheet->getCell("C" . $valline)->getFormattedValue();
				$price = $sheet->getCell("D" . $valline)->getFormattedValue();
				$vat = $sheet->getCell("E" . $valline)->getFormattedValue();
				$ean = $sheet->getCell("F" . $valline)->getFormattedValue();
				$cSale = $sheet->getCell("G" . $valline)->getFormattedValue();
				$cBuy = $sheet->getCell("H" . $valline)->getFormattedValue();
				$cIntraCode = $sheet->getCell("I" . $valline)->getFormattedValue();
				$warehouse = $sheet->getCell("J" . $valline)->getFormattedValue();
				$ecotax = $sheet->getCell("K" . $valline)->getFormattedValue();
				$sorecop = $sheet->getCell("L" . $valline)->getFormattedValue();
				$mark = $sheet->getCell("M" . $valline)->getFormattedValue();
				$range = $sheet->getCell("N" . $valline)->getFormattedValue();
				$category = $sheet->getCell("O" . $valline)->getFormattedValue();
				$inSale = $sheet->getCell("P" . $valline)->getFormattedValue();
				$inBuy = $sheet->getCell("Q" . $valline)->getFormattedValue();
				$supplier = $sheet->getCell("R" . $valline)->getFormattedValue();
				$supplierPrice = $sheet->getCell("S" . $valline)->getFormattedValue();
				$supplierVat = $sheet->getCell("T" . $valline)->getFormattedValue();
				$supplierQty = $sheet->getCell("U" . $valline)->getFormattedValue();

				$product = new Product($this->db);
				$product->fetch('', $ref);

				if (empty($ref) || (empty($product->id) && (empty($label) || empty($price) || empty($vat) || empty($ean) || empty($inBuy) || empty($inSale) || empty($supplier) || empty($supplierPrice)))) {
					$error++;
					if ($error == 1) {
						$fileerror = new PHPExcel();
						$sheeterror = $fileerror->getActiveSheet();
						$sheeterror->setCellValue('A' . $j, $langs->trans("Ref"));
						$sheeterror->setCellValue('B' . $j, $langs->trans("Label"));
						$sheeterror->setCellValue('C' . $j, $langs->trans("Description"));
						$sheeterror->setCellValue('D' . $j, $langs->trans("SalePrice"));
						$sheeterror->setCellValue('E' . $j, $langs->trans("VAT"));
						$sheeterror->setCellValue('F' . $j, $langs->trans("EAN13"));
						$sheeterror->setCellValue('G' . $j, $langs->trans("AccountingSaleCode"));
						$sheeterror->setCellValue('H' . $j, $langs->trans("AccountingBuyCode"));
						$sheeterror->setCellValue('I' . $j, $langs->trans("AccountingIntraCode"));
						$sheeterror->setCellValue('J' . $j, $langs->trans("Warehouse"));
						$sheeterror->setCellValue('K' . $j, $langs->trans("Ecotax"));
						$sheeterror->setCellValue('L' . $j, $langs->trans("Sorecop"));
						$sheeterror->setCellValue('M' . $j, $langs->trans("Mark"));
						$sheeterror->setCellValue('N' . $j, $langs->trans("Range"));
						$sheeterror->setCellValue('O' . $j, $langs->trans("Category"));
						$sheeterror->setCellValue('P' . $j, $langs->trans("InSale"));
						$sheeterror->setCellValue('Q' . $j, $langs->trans("InBuy"));
						$sheeterror->setCellValue('R' . $j, $langs->trans("Supplier"));
						$sheeterror->setCellValue('S' . $j, $langs->trans("SupplierPrice"));
						$sheeterror->setCellValue('T' . $j, $langs->trans("SupplierVat"));
						$sheeterror->setCellValue('U' . $j, $langs->trans("SupplierQty"));
						$j++;
					}
					$sheeterror->setCellValue('A' . $j, $ref);
					$sheeterror->setCellValue('B' . $j, $label);
					$sheeterror->setCellValue('C' . $j, $desc);
					$sheeterror->setCellValue('D' . $j, $price);
					$sheeterror->setCellValue('E' . $j, $vat);
					$sheeterror->setCellValue('F' . $j, $ean);
					$sheeterror->setCellValue('G' . $j, $cSale);
					$sheeterror->setCellValue('H' . $j, $cBuy);
					$sheeterror->setCellValue('I' . $j, $cIntraCode);
					$sheeterror->setCellValue('J' . $j, $warehouse);
					$sheeterror->setCellValue('K' . $j, $ecotax);
					$sheeterror->setCellValue('L' . $j, $sorecop);
					$sheeterror->setCellValue('M' . $j, $mark);
					$sheeterror->setCellValue('N' . $j, $range);
					$sheeterror->setCellValue('O' . $j, $category);
					$sheeterror->setCellValue('P' . $j, $inSale);
					$sheeterror->setCellValue('Q' . $j, $inBuy);
					$sheeterror->setCellValue('R' . $j, $supplier);
					$sheeterror->setCellValue('S' . $j, $supplierPrice);
					$sheeterror->setCellValue('T' . $j, $supplierVat);
					$sheeterror->setCellValue('U' . $j, $supplierQty);

					$j++;

					echo '<tr><td style="background-color: indianred">' . $i . '</td>';
				} else {
					if (!empty($product->id)) {
						echo '<tr><td style="background-color: darkorange">' . $i . '</td>';
					} else {
						echo '<tr><td style="background-color: yellowgreen">' . $i . '</td>';
					}
				}
				echo '<td>' . $ref . '</td>
						<td>' . $label . '</td>
							<td>' . $desc . '</td>
							<td>' . $price . '</td>
							<td>' . $vat . '</td>
							<td>' . $ean . '</td>
							<td>' . $cSale . '</td>
							<td>' . $cBuy . '</td>
							<td>' . $cIntraCode . '</td>
							<td>' . $warehouse . '</td>
							<td>' . $ecotax . '</td>
							<td>' . $sorecop . '</td>
							<td>' . $mark . '</td>
							<td>' . $range . '</td>
							<td>' . $category . '</td>
							<td>' . $inSale . '</td>
							<td>' . $inBuy . '</td>
							<td>' . $supplier . '</td>
							<td>' . $supplierPrice . '</td>
							<td>' . $supplierVat . '</td>
							<td>' . $supplierQty . '</td>
							</tr>';

				if ($i % 20 == 0) {
					echo '<table class="tagtable liste"><tr>
			<th>' . $langs->trans("Line") . '</th>
			<th>' . $langs->trans("Ref") . '</th>
			<th>' . $langs->trans("Label") . '</th>
			<th>' . $langs->trans("Description") . '</th>
			<th>' . $langs->trans("SalePrice") . '</th>
			<th>' . $langs->trans("VAT") . '</th>
			<th>' . $langs->trans("EAN13") . '</th>
			<th>' . $langs->trans("AccountingSaleCode") . '</th>
			<th>' . $langs->trans("AccountingBuyCode") . '</th>
			<th>' . $langs->trans("AccountingIntraCode") . '</th>
			<th>' . $langs->trans("Warehouse") . '</th>
			<th>' . $langs->trans("Ecotax") . '</th>
			<th>' . $langs->trans("Sorecop") . '</th>
			<th>' . $langs->trans("Mark") . '</th>
			<th>' . $langs->trans("Range") . '</th>
			<th>' . $langs->trans("Category") . '</th>
			<th>' . $langs->trans("InSale") . '</th>
			<th>' . $langs->trans("InBuy") . '</th>
			<th>' . $langs->trans("Supplier") . '</th>
			<th>' . $langs->trans("SupplierPrice") . '</th>
			<th>' . $langs->trans("SupplierVat") . '</th>
			<th>' . $langs->trans("SupplierQty") . '</th>
			</tr>';
				}
				$i++;
			}
			echo '</table>';
			echo "<a href='" . dol_buildpath('importupdateproduct/importupdateproductindex.php',
					1) . "' class='button'>Retour</a>        ";
			if (empty($error)) {
				echo "<a href='" . dol_buildpath('importupdateproduct/importupdateproductindex.php?fimport=' . $file . '&' . 'import=1',
						1) . "' class='button'>Lancer l'import</a>        ";
				exit;
				//$this->sheetprocess($file);
			} else {
				echo "<a href='" . dol_buildpath('importupdateproduct/importupdateproductindex.php?fimport=' . $file . '&' . 'import=1',
						1) . "' class='button'>Lancer l'import hors lignes en erreur</a>";
				$objWriter = PHPExcel_IOFactory::createWriter($fileerror, 'Excel2007');
				$link = 'erreur_import_' . date('YYmdhi', time()) . '.xlsx';
				$objWriter->save($conf->importupdateproduct->dir_output . '/' . $link);

				echo '<a href="' . dol_buildpath('/document.php?modulepart=importupdateproduct&file=' . $link,
						1) . '" class="button">Fichier Erreur</a>';
				exit;
			}
		}
	}

	public function sheetprocess($file)
	{

		global $user, $conf, $langs;
		if (file_exists($file)) {
			// Chargement du fichier Excel
			$objPHPExcel = PHPExcel_IOFactory::load($file);

			/**
			 * récupération de la première feuille du fichier Excel
			 * @var PHPExcel_Worksheet $sheet
			 */
			$sheet = $objPHPExcel->getSheet(0);
			$factures = $testarray = array();
			$error = 0;

			// On boucle sur les lignes
			$i = 0;
			foreach ($sheet->getRowIterator() as $valline => $row) {
				if ($i == 0) {
					$i = 1;
					continue;
				}

				$ref = $sheet->getCell("A" . $valline)->getFormattedValue();
				$label = $sheet->getCell("B" . $valline)->getFormattedValue();
				$desc = $sheet->getCell("C" . $valline)->getFormattedValue();
				$price = $sheet->getCell("D" . $valline)->getFormattedValue();
				$vat = $sheet->getCell("E" . $valline)->getFormattedValue();
				$ean = $sheet->getCell("F" . $valline)->getFormattedValue();
				$cSale = $sheet->getCell("G" . $valline)->getFormattedValue();
				$cBuy = $sheet->getCell("H" . $valline)->getFormattedValue();
				$cIntraCode = $sheet->getCell("I" . $valline)->getFormattedValue();
				$warehouse = $sheet->getCell("J" . $valline)->getFormattedValue();
				$ecotax = $sheet->getCell("K" . $valline)->getFormattedValue();
				$sorecop = $sheet->getCell("L" . $valline)->getFormattedValue();
				$mark = $sheet->getCell("M" . $valline)->getFormattedValue();
				$range = $sheet->getCell("N" . $valline)->getFormattedValue();
				$category = $sheet->getCell("O" . $valline)->getFormattedValue();
				$inSale = $sheet->getCell("P" . $valline)->getFormattedValue();
				$inBuy = $sheet->getCell("Q" . $valline)->getFormattedValue();
				$supplier = $sheet->getCell("R" . $valline)->getFormattedValue();
				$supplierPrice = $sheet->getCell("S" . $valline)->getFormattedValue();
				$supplierVat = $sheet->getCell("T" . $valline)->getFormattedValue();
				$supplierQty = $sheet->getCell("U" . $valline)->getFormattedValue();

				$product = new Product($this->db);
				$product->fetch('', $ref);

				if (!empty($label)) {
					$product->label = $label;
				}
				if (!empty($desc)) {
					$product->description = $desc;
				}
				if (!empty($price)) {
					$product->price = $price;
					$product->price_ttc = $price + ($price*$vat/100);
				}
				if ($vat==0 || !empty($vat)) {
					$product->tva_tx = $vat;
				}
				if (!empty($ean)) {
					$product->barcode = str_replace(".", "", $ean);
				}
				if (!empty($cSale)) {
					$product->accountancy_code_sell = $cSale;
				}
				if (!empty($cIntraCode)) {
					$product->accountancy_code_sell_intra = $cIntraCode;
				}
				if (!empty($cBuy)) {
					$product->accountancy_code_buy = $cBuy;
				}
				if (!empty($warehouse)) {
					$ent = new Entrepot($this->db);
					$ent->fetch('', $warehouse);
					$product->fk_default_warehouse = $ent->id;
				}
				if (!empty($ecotax)) {
					$product->array_options['options_ecotaxdeee'] = $ecotax;
				}
				if (empty($ecotax)) {
					$product->array_options['options_ecotaxdeee'] = "NULL";
				}
				if (!empty($sorecop)) {
					$product->array_options['options_sorecop'] = $sorecop;
				}
				if (empty($sorecop)) {
					$product->array_options['options_sorecop'] = "NULL";
				}
				if (!empty($mark)) {
					$product->array_options['options_importupdateproduct_mark'] = $mark;
				}
				if (!empty($range)) {
					$product->array_options['options_importupdateproduct_range'] = $range;
				}
				if ($inSale==0 || $inSale==1) {
					$product->status = $inSale;
				}
				if ($inBuy==0 || $inBuy==1) {
					$product->status_buy = $inBuy;
				}
				$product->price_base_type ="HT";

				//if(!empty($supplier)) $product-> = $label;
				//TO DO supplier

				if (!empty($product->id)) {
					if (!empty($ref)) {
						$product->update($product->id, $user);

						$product->updatePrice($product->price, $product->price_base_type, $user, $product->tva_tx);
						if (!empty($category)) {
							//$cat = preg_split('#/#', $category);
							$catid = array();
							//echo "<pre>" . print_r($cat, 1) . "</pre>";

							$c = new Categorie($this->db);
							$c->fetch('', $category);
							$catid[]=$c->id;

							//echo "<pre>" . print_r($catid, 1) . "</pre>";
							$product->setCategories($catid);
						}
						if(!empty($supplier)){
							$sup = new Fournisseur($this->db);
							$sup->fetch('', $supplier);


							if(!empty($sup->id) && !empty($supplierPrice)){
								$supp = new ProductFournisseur($this->db);
								$allprod = $supp->list_product_fournisseur_price($product->id);
								foreach($allprod as $all) {
									if($all->fourn_name == $supplier && $all->ref_supplier = $ref) {
										if (!empty($all->product_fourn_price_id)) {
											if($conf->multicurrency->enabled)
												$ret = $all->update_buyprice($supplierQty, $supplierPrice, $user, 'HT', $sup, '', $ref, $supplierVat, 0, 0, 0, 0, 0, '', array(), '', $supplierPrice, 'HT');
											else
												$ret = $all->update_buyprice($supplierQty, $supplierPrice, $user, 'HT', $sup, '', $ref, $supplierVat);
										} else {
											$ids = $product->add_fournisseur($user, $sup->id, $ref, $supplierQty);
											if (!empty($ids)) {
												if($conf->multicurrency->enabled)
													$ret = $all->update_buyprice($supplierQty, $supplierPrice, $user, 'HT', $sup, '', $ref, $supplierVat, 0, 0, 0, 0, 0, '', array(), '', $supplierPrice, 'HT');
												else
													$ret = $all->update_buyprice($supplierQty, $supplierPrice, $user, 'HT', $sup, '', $ref, $supplierVat);
											}
										}
									}
								}
							}
						}
					}
				} else {
					if (!empty($ref)  && !empty($label) && !empty($price) && !empty($vat) && !empty($ean) && !empty($inBuy) && !empty($inSale) && !empty($supplier) && !empty($supplierPrice)) {
						$product->ref = $ref;
						$product->barcode_type = 2;

						$product->create($user);
						//$product->fetch($pid);

						if($product->id > 0) {
							if (!empty($category)) {
								$catid = array();

								$c = new Categorie($this->db);
								$c->fetch('', $category);
								$catid[] = $c->id;

								$product->setCategories($catid);

								if(!empty($supplier)){
									$sup = new Fournisseur($this->db);
									$sup->fetch('', $supplier);


									if(!empty($sup->id) && !empty($supplierPrice)){
										$ids = $product->add_fournisseur($user, $sup->id, $ref,
											$supplierQty);
										$supp = new ProductFournisseur($this->db);
										$allprod = $supp->list_product_fournisseur_price($product->id);
										foreach ($allprod as $all) {
											if ($all->fourn_name == $supplier && $all->ref_supplier = $ref) {
												if (!empty($all->product_fourn_price_id)) {
													if ($conf->multicurrency->enabled) {
														$ret = $all->update_buyprice($supplierQty, $supplierPrice,
															$user, 'HT', $sup, '', $ref, $supplierVat, 0, 0, 0, 0,
															0, '', array(), '', $supplierPrice, 'HT');
													} else {
														$ret = $all->update_buyprice($supplierQty, $supplierPrice,
															$user, 'HT', $sup, '', $ref, $supplierVat);
													}
												} else {
													$ids = $product->add_fournisseur($user, $sup->id, $ref,
														$supplierQty);
													if (!empty($ids)) {
														if ($conf->multicurrency->enabled) {
															$ret = $all->update_buyprice($supplierQty,
																$supplierPrice, $user, 'HT', $sup, '', $ref,
																$supplierVat, 0, 0, 0, 0, 0, '', array(), '',
																$supplierPrice, 'HT');
														} else {
															$ret = $all->update_buyprice($supplierQty,
																$supplierPrice, $user, 'HT', $sup, '', $ref,
																$supplierVat);
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
